"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.Client = void 0;
var axios_1 = __importDefault(require("axios"));
var https_proxy_agent_1 = require("https-proxy-agent");
var ws_1 = require("ws");
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    /**
     * Client Class
     * @param pageID should be the trakteer page id (NOT Username). check pageID in https://trakteer.id/manage/my-page/settings
     * @param streamKey should be `trstream-xxx`. check key in https://trakteer.id/manage/stream-settings
     */
    function Client(pageID, streamKey, proxy) {
        var _this = _super.call(this) || this;
        _this.messages = [];
        _this.username = pageID;
        _this.streamKey = streamKey;
        _this.agent = !!proxy ? new https_proxy_agent_1.HttpsProxyAgent(proxy) : undefined;
        _this.client = new ws_1.WebSocket("wss://socket.trakteer.id/app/2ae25d102cc6cd41100a?protocol=7&client=js&version=5.1.1&flash=false", {
            agent: _this.agent
        });
        // It will connect automatically. instead of calling this.start(). start will be useless now
        _this.client.once("open", function () {
            axios_1["default"].get("https://trakteer.id/" + _this.username + "/stream?key=" + _this.streamKey, {
                httpsAgent: _this.agent
            }).then(function (data) {
                var userid = data.data;
                var result = (/creator-stream\.(.*?)\./gi.exec(userid));
                if (!data.data || !result || !result[1])
                    throw new Error("Failed to read userId data! Invalid key/username?");
                else
                    _this.userId = result[1];
                //Subscribe ke Streaming agar mendapatkan feedback
                _this.client.send(JSON.stringify({
                    event: "pusher:subscribe",
                    data: {
                        auth: "",
                        channel: "creator-stream." + _this.userId + "." + _this.streamKey
                    }
                }));
                // Kirim ping agar tidak di disconnect
                _this.pingInterval = setInterval(function () {
                    _this.client.send(JSON.stringify({
                        data: {},
                        event: "pusher:ping"
                    }));
                }, 5000);
                //Subscribe ke Streaming test agar mendapatkan feedback
                _this.client.send(JSON.stringify({
                    event: "pusher:subscribe",
                    data: {
                        auth: "",
                        channel: "creator-stream-test." + _this.userId + "." + _this.streamKey
                    }
                }));
                _this.emit("connect", new Date());
            });
        });
        _this.client.on("message", function (message) {
            if (message.toString().startsWith("{\"channel\"")) {
                _this.emit("donation", JSON.parse(JSON.parse(message.toString()).data));
            }
        });
        _this.client.once("close", function (code, reason) {
            _this.emit("disconnect", new Date());
        });
        return _this;
    }
    /**
     * @deprecated this will do nothing. will remove it in later version. please remove this line
     *
     */
    Client.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Donation Leaderboard
     * @param dayInterval Get Donation from last x day
     * @param maxAmount Max Amount of leadedrboard
     * @param sortBy Sort By Rupiah amount or Unit Amount
     * @returns Leaderboard
     */
    Client.prototype.getLeaderboard = function (dayInterval, maxAmount, sortBy) {
        if (dayInterval === void 0) { dayInterval = 7; }
        if (maxAmount === void 0) { maxAmount = 10; }
        if (sortBy === void 0) { sortBy = "unit"; }
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1["default"].get("https://api.trakteer.id/v2/stream/" + this.streamKey + "/top-supporters?interval=" + dayInterval + "&count=" + maxAmount + "&sortby=" + sortBy, {
                            httpsAgent: this.agent
                        })];
                    case 1:
                        data = (_a.sent()).data;
                        data.unitIcon = /"(.+?)"/gm.exec(data.unitIcon)[1];
                        data.supporter = data.supporter.map(function (x) {
                            x.sum = parseInt(x.sum);
                            return x;
                        });
                        return [2 /*return*/, data];
                }
            });
        });
    };
    /**
     * Get Supporter from all time
     * @param amount Amount of supporter to get
     * @returns supporter list
     */
    Client.prototype.getSupporter = function (amount) {
        if (amount === void 0) { amount = 10; }
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, axios_1["default"].get("https://api.trakteer.id/v2/stream/" + this.streamKey + "/latest-tips?limit=" + amount, {
                            httpsAgent: this.agent
                        })];
                    case 1:
                        data = (_a.sent()).data.latestTip;
                        return [2 /*return*/, data];
                }
            });
        });
    };
    /**
     * Get Goal
     * @returns Goal
     */
    Client.prototype.getGoal = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, _a, currentGoal, targetGoal;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, axios_1["default"].get("https://api.trakteer.id/v2/stream/" + this.streamKey + "/target-data", {
                            httpsAgent: this.agent
                        })];
                    case 1:
                        data = (_b.sent()).data;
                        _a = data.targetValue
                            .replace(/\./g, "")
                            .split("/")
                            .map(function (x) { return parseFloat(x.replace("Rp ", "")); }), currentGoal = _a[0], targetGoal = _a[1];
                        // A bit long, lul. short this please loll
                        // 'Rp 0 / Rp 75.000' <~ This should be the original text.
                        return [2 /*return*/, {
                                target: {
                                    current: currentGoal,
                                    target: targetGoal,
                                    progress: parseInt(data.targetProgress)
                                },
                                title: data.targetTitle,
                                url: data.pageUrl
                            }];
                }
            });
        });
    };
    /**
     *
     * @param cb This will triggered when The client is ready.
     * @deprecated This will removed on later version, please use `client.on("open")` instead.
     */
    Client.prototype.onOpen = function (cb) {
        this.client.on("open", function () {
            cb(true);
            return;
        });
    };
    /**
     *
     * @param cb This will triggered when donation is detected
     * @deprecated This will removed on later version, please use `client.on("donation")` instead.
     */
    Client.prototype.onDonation = function (cb) {
        this.client.on("message", function (message) {
            if (message.toString().startsWith("{\"channel\"")) {
                cb(JSON.parse(JSON.parse(message.toString()).data));
            }
        });
    };
    return Client;
}(ws_1.EventEmitter));
exports.Client = Client;
